<?php
namespace Teknisa\PLA\Modules\Cardapio\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use \Setforms2\Shared\ORM\DateTime;
use \Setforms2\Shared\ORM\TimeZone;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class Pla11800ReplicacaoMensalDoCardapioService {

    protected $environment;
    protected $entityManager;
    protected $connection;

	public function __construct($environment, $entityManager, $connection) {
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->connection = $connection;

    }

    public function getServicos($params) {
        $query = "SELECT
            F.CDFILIAL || ' | ' || F.NMFILIAL AS NMFILIAL,
            S.CDSERVFILI,
            S.NMSERVICO
        FROM SERVICO   S
            INNER JOIN FILIAL    F ON F.CDFILIAL = S.CDFILIAL AND F.IDCNTRRESC = 'N'
        WHERE
            VALOR_NA_LISTA(S.CDFILIAL, :P_CDFILIAL) > 0
            AND VALOR_NA_LISTA(S.CDGRUPSERV, :P_CDGRUPSERV) > 0
            AND NVL(S.IDCARDDESCENTR, 'N') <> 'S'
            AND EXISTS (
                SELECT
                    1
                FROM CARDADIA C  INNER JOIN COMPCARD CM ON C.CDFILIAL = CM.CDFILIAL and C.NRCARDAPIO=CM.NRCARDAPIO
                WHERE
                    C.CDFILIAL = S.CDFILIAL
                    AND C.CDSERVFILI = S.CDSERVFILI
                    AND C.DTCARDAPIO BETWEEN TO_DATE(:P_DTCARDAPIO, 'DD/MM/YYYY') AND LAST_DAY(TO_DATE(:P_DTCARDAPIO, 'DD/MM/YYYY'))
            )
            AND (( :P_CDGRUPFILI = 'T' )
                OR ( EXISTS (
                    SELECT
                        1
                    FROM FILGRUPFILI G
                    WHERE
                        G.CDFILIAL = S.CDFILIAL
                        AND G.CDGRUPFILI = :P_CDGRUPFILI
                )))
            ORDER BY
                S.CDFILIAL,
                S.CDSERVFILI";

        return $this->entityManager->getConnection()->fetchAll($query, $params);
    }

    public function replicaCardapioPlaProcedure($params) {
        $procedure = new StoredProcedure($this->connection, 'REPLICA_CARDAPIO_PLA');
        $procedure->addParam(new Param('P_DTCARDORI', Param::PARAM_INPUT, $params['P_DTCARDORI'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_SERVICOS', Param::PARAM_INPUT, $params['P_SERVICOS'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_MAPADIAS', Param::PARAM_INPUT, $params['P_MAPADIAS'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $params['P_CDOPERADOR'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILIALLOGADA', Param::PARAM_INPUT, $params['P_CDFILIALLOGADA'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRORG', Param::PARAM_INPUT, $params['P_NRORG'], Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_LISTAERROS',   Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 20));
        
        $listaErros = $procedure->execute();

        return $listaErros;
    }
}