<?php
namespace Teknisa\PLA\Modules\Parametros\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;


class Pla06500OpcoesProdutosController extends \Teknisa\GER\Controllers\TeknisaCrud {
	protected $parameterBagColumns;
	protected $crudService;
	protected $dataSourceManager;
	protected $environment;
	protected $parameterBag;
	
	public function __construct($crudService, $parameterBag, $dataSourceManager, $environment, $entityManager){
		$this->crudService 	        = $crudService;
	    $this->parameterBag         = $parameterBag;
		$this->dataSourceManager    = $dataSourceManager;
		$this->environment 			= $environment;
		$this->entityManager        = $entityManager;

		parent::__construct($crudService, $parameterBag);
	}
	
	public function VerificaArvoreProduto(DTO\Request $request, DTO\Response $response) {
		$row = $request->getRow();
		$sql = 'SELECT
            PO.CDPRODUTO AS "CDPRODUTO",
            PO.CDARVPROD AS "CDARVPRINC",
            PC.CDARVPROD AS "CDARVOPC",
            PO.NMPRODUTO AS "NMPRODPRINC",
            PC.NMPRODUTO AS "NMPRODOPC",
            O.CDPRORIGREC AS "CDPRORIGREC",
            O.CDPROPCREC AS "CDPROPCREC",
            PO.CDNVPRODUTO AS "CDNVPRODUTO",
            PO.CDPRODNIVANTE AS "CDPRODNIVANTE"
        FROM
            OPCPRODREC O,
            PRODUTO    PO,
            PRODUTO    PC
        WHERE
                O.CDPRORIGREC = PO.CDPRODUTO
            AND O.CDPROPCREC = PC.CDPRODUTO
            AND PO.CDARVPROD = :CDARVPROD
        ORDER BY
            PO.CDARVPROD';
                    
		$params = array("CDARVPROD" => $row['CDARVORIG']);
		$query = $this->entityManager->getConnection()->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();
        $response->addDataSet(new DataSet("TREE", $result));
	}
}