<?php
namespace Teknisa\PLA\Modules\Parametros\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\GER\Services\CrudService;
use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use Exception;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Pla05000CombinacaoPratosService extends \Teknisa\GER\Controllers\TeknisaCrud{
    
    
    public function __construct($crudservice, $parameterbag, $entityManager){
        $this->crudservice   = $crudservice;
        $this->parameterbag  = $parameterbag;
        $this->entityManager = $entityManager;
        $this->connection    = $entityManager->getConnection();
        
        parent::__construct($crudservice, $parameterbag);
    }
    
    public function savePai($row) {
        $params = array(':NRCOMBGRUPOTPPRAT' => $row['NRCOMBGRUPOTPPRAT'], ':CDGRTIPOPR' => $row['CDGRTIPOPRPAI'], ':CDPRATO' => $row['CDPRATOPAI'], ':CDFILAUXPRAT' => $row['CDFILAUXPRATPAI'], ':CDFILIAL' => $row['CDFILIAL']);
        $sql = "INSERT INTO COMBGRUPOTPPRAT (NRCOMBGRUPOTPPRAT, CDGRTIPOPR, CDPRATO, CDFILAUXPRAT, CDFILIAL) VALUES (:NRCOMBGRUPOTPPRAT, :CDGRTIPOPR, :CDPRATO, :CDFILAUXPRAT, :CDFILIAL)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function saveFilho($row) {
        $params = array(':NRITCOMBGRUPOTPPRAT' => $row['NRITCOMBGRUPOTPPRAT'], ':NRCOMBGRUPOTPPRAT' => $row['NRCOMBGRUPOTPPRAT'], ':CDGRTIPOPR' => $row['CDGRTIPOPRFILHO'], ':CDPRATO' => $row['CDPRATOFILHO'], ':IDCOMBINACAO' => $row['IDCOMBINACAO'], ':CDFILAUXPRAT' => $row['CDFILAUXPRATFILHO'], ':PERCENTREDUCAO' => $row['PERCENTREDUCAO']);
        $sql = "INSERT INTO ITCOMBGRUPOTPPRAT (NRITCOMBGRUPOTPPRAT, NRCOMBGRUPOTPPRAT, CDGRTIPOPR, CDPRATO, IDCOMBINACAO, CDFILAUXPRAT, PERCENTREDUCAO) VALUES (:NRITCOMBGRUPOTPPRAT, :NRCOMBGRUPOTPPRAT, :CDGRTIPOPR, :CDPRATO, :IDCOMBINACAO, :CDFILAUXPRAT, :PERCENTREDUCAO)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function deletarFilho($row) {
        $params = array(':NRITCOMBGRUPOTPPRAT' => $row['NRITCOMBGRUPOTPPRAT']);
        $sql = "DELETE FROM ITCOMBGRUPOTPPRAT WHERE NRITCOMBGRUPOTPPRAT = :NRITCOMBGRUPOTPPRAT";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}